//+------------------------------------------------------------------+
//|                                     smAutoFiboRetracement_v1.mq4 |
//|                                 Copyright  2010.01.29, SwingMan |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010.01.29, SwingMan"
#property link      ""

#property indicator_chart_window

//---- extern inputs
//+------------------------------------------------------------------+
extern int maxBarsBack = 21;
//+------------------------------------------------------------------+

datetime oldTime1, oldTime2;
double oldPrice1, oldPrice2;
string sName = "autoFibo_";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectDelete(sName);
   return(0);
}
  
//####################################################################  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
datetime time1, time2;
double price1, price2;

   int    counted_bars=IndicatorCounted();
//----
   Get_FiboData(time1,price1, time2,price2);
   if (oldTime1 != time1 || oldTime2 != time2 || oldPrice1 != price1 || oldPrice2 != price2)
   {
      oldTime1  = time1;
      oldTime2  = time2;
      oldPrice1 = price1; 
      oldPrice2 = price2;
      Set_FiboRetracement(time1,price1, time2,price2);
   }  
   
   return(0);
}
//+------------------------------------------------------------------+

//___________________________________________________________________
void Set_FiboRetracement(datetime time1, double price1, datetime time2, double price2)
{
   ObjectDelete(sName);
   ObjectCreate(sName,OBJ_FIBO,0, time2,price2, time1,price1);
      ObjectSet(sName,OBJPROP_LEVELCOLOR,DarkOrange);
      ObjectSet(sName,OBJPROP_LEVELSTYLE,STYLE_DOT);
      
      ObjectSet(sName,OBJPROP_FIBOLEVELS,8);
      
      ObjectSet(sName,OBJPROP_FIRSTLEVEL+0,0.000);
      ObjectSet(sName,OBJPROP_FIRSTLEVEL+1,0.236);
      ObjectSet(sName,OBJPROP_FIRSTLEVEL+2,0.382);
      ObjectSet(sName,OBJPROP_FIRSTLEVEL+3,0.500);
      ObjectSet(sName,OBJPROP_FIRSTLEVEL+4,0.618);
      ObjectSet(sName,OBJPROP_FIRSTLEVEL+5,1.000);
      ObjectSet(sName,OBJPROP_FIRSTLEVEL+6,1.618);
      ObjectSet(sName,OBJPROP_FIRSTLEVEL+7,2.618);
      
      for(int j = 0; j < 8; j++)
      {
         //if(GetLastError() != 0) break;
         ObjectSetFiboDescription(sName, j, "(" + 
            DoubleToStr(ObjectGet(sName,OBJPROP_FIRSTLEVEL+j)*100,1) + ")" + "  %$");
      }
}

//___________________________________________________________________
void Get_FiboData(datetime& time1, double& price1, datetime& time2, double& price2)
{
int j, barLow, barHigh;
bool barFound;
double minLow, maxHigh;

   //---- find lower low --------------------------------------------
   barLow = -1;
   barFound = false;  
   while (barFound == false)
   {
      barLow++;
      minLow = Low[barLow];  
      for (j=0; j<maxBarsBack; j++)
      {
         if (Low[barLow + j] < minLow)
            break;
      }
      //---- lower low found
      if (j >= maxBarsBack)
         barFound = true;
   }
   
   //---- find higher high ------------------------------------------
   barHigh = -1;
   barFound = false;  
   while (barFound == false)
   {
      barHigh++;
      maxHigh = High[barHigh];  
      for (j=0; j<maxBarsBack; j++)
      {
         if (High[barHigh + j] > maxHigh)
            break;
      }
      if (j >= maxBarsBack)
         barFound = true;
   }

   //---- fibo data
   if (barLow > barHigh)
   {
      time1 = Time[barLow];  price1 = Low[barLow];
      time2 = Time[barHigh]; price2 = High[barHigh];
   }   
   else{
      time2 = Time[barLow];  price2 = Low[barLow];
      time1 = Time[barHigh]; price1 = High[barHigh];
   }   
   return;
}